DROP TABLE IF EXISTS Users;
DROP TABLE IF EXISTS Groups;
DROP TABLE IF EXISTS Organizations;

CREATE TABLE GROUPS
(
    ID INTEGER PRIMARY KEY AUTO_INCREMENT NOT NULL,
    GID VARCHAR(32) NOT NULL,
    NAME VARCHAR(32) DEFAULT '' NOT NULL,
    DESCRIPTION VARCHAR(32),
    TIMESTAMP TIMESTAMP
);
CREATE TABLE ORGANIZATIONS
(
    ID INTEGER PRIMARY KEY AUTO_INCREMENT NOT NULL,
    NAME VARCHAR(32) DEFAULT '' NOT NULL,
    DESCRIPTION VARCHAR(32),
    TIMESTAMP TIMESTAMP
);
CREATE TABLE USERS
(
    ID INTEGER PRIMARY KEY AUTO_INCREMENT NOT NULL,
    UID VARCHAR(32) NOT NULL,
    FIRSTNAME VARCHAR(32) DEFAULT '' NOT NULL,
    LASTNAME VARCHAR(32) DEFAULT '' NOT NULL,
    DISPLAYNAME VARCHAR(64),
    EMAIL VARCHAR(64),
    EMPLOYEENUMBER VARCHAR(32),
    EMPLOYEETYPE VARCHAR(32),
    DESCRIPTION VARCHAR(64),
    MOBILEPHONE VARCHAR(64),
    TIMESTAMP TIMESTAMP
);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('bob','Bob', 'Fleming','Bob Fleming','Bob.Fleming@example.com','100','employee','Employee Bob Fleming','123-456-789',CURRENT_TIMESTAMP);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('rowley','Rowley','Birkin','Rowley Birkin','Rowley.Birkin@example.com','101','employee','Employee Rowley Birkin','345-234-543',CURRENT_TIMESTAMP);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('louis','Louis', 'Balfour','Louis Balfour','Louis.Balfour@example.com','102','employee','Employee Louis Balfour','876-678-098',CURRENT_TIMESTAMP);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('john','John', 'Smith','John Smith','John.Smith@example.com','103','employee','Employee John Smith','634-123-456',CURRENT_TIMESTAMP);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('jdoe','John', 'Doe','John Doe','John.Doe@example.com','104','employee','Employee John Doe','125-785-645',CURRENT_TIMESTAMP);
INSERT INTO Users(UID,FIRSTNAME,LASTNAME,DISPLAYNAME,EMAIL,EMPLOYEENUMBER,EMPLOYEETYPE,DESCRIPTION,MOBILEPHONE,TIMESTAMP) VALUES ('chris','Chris', 'Crafty','Chris Crafty','Chris.Crafty@example.com','105','contractor','Employee Chris Crafty','888-666-555',CURRENT_TIMESTAMP);

INSERT INTO Groups(GID,NAME,DESCRIPTION,TIMESTAMP) VALUES ('100','admin','Admin group',CURRENT_TIMESTAMP);
INSERT INTO Groups(GID,NAME,DESCRIPTION,TIMESTAMP) VALUES ('101','users','Users group',CURRENT_TIMESTAMP);
INSERT INTO Groups(GID,NAME,DESCRIPTION,TIMESTAMP) VALUES ('102','security','Security group',CURRENT_TIMESTAMP);

INSERT INTO Organizations(NAME,DESCRIPTION,TIMESTAMP) VALUES ('HR','HR organization',CURRENT_TIMESTAMP);
INSERT INTO Organizations(NAME,DESCRIPTION,TIMESTAMP) VALUES ('SALES','Sales organization',CURRENT_TIMESTAMP);
INSERT INTO Organizations(NAME,DESCRIPTION,TIMESTAMP) VALUES ('SUPPORT','Support organization',CURRENT_TIMESTAMP);
INSERT INTO Organizations(NAME,DESCRIPTION,TIMESTAMP) VALUES ('ENG','Engineering organization',CURRENT_TIMESTAMP);
INSERT INTO Organizations(NAME,DESCRIPTION,TIMESTAMP) VALUES ('OPERATIONS','Operations organization',CURRENT_TIMESTAMP);

